import logo from './logo.svg';
import './App.css';
import React, { useEffect, useState } from 'react';

// TimerContainer
const SecondsTimer = ({ seconds }) => <h2>{seconds}</h2>

const TimerContainer = ({ seconds, refresh, render }) => {
    const [count, setCount] = useState(seconds) // отслеживаем состояние количества секунд
    const [isRunning, setIsRunning] = useState(false) // отслеживаем состояние кнопки стоп/старт для таймера
    const Render = render

    useEffect(() => { setCount(seconds) }, [seconds]) // синхронизируем count с передаваемыми seconds

    console.log('count ', count)

    useEffect(() => { // эффект, отвечающий за то, когда счетчик прошле в 0, он его переводит в состояние паузы
        if (count <= 0) {
            setIsRunning(false)
        }
    }, [count <= 0])

    useEffect(() => { // сам счетчик
        if (isRunning) {
            const start = performance.now()

            const int = setInterval(() => {

                const diff = Math.floor((performance.now() - start) / refresh)
                setCount(count => count - diff)
            }, refresh)

            return () => clearInterval(int)
        }
    })

    return (
        <div>
            <h2>TimerContainer</h2>
            <Render seconds={count} />
            <button onClick={() => setIsRunning(!isRunning)}>{isRunning ? 'Pause' : 'Start'}</button>
        </div >
    )
}

function App() {
    return (
        <div className="App">
            <header>

                {/* TimerContainer */}
                <TimerContainer seconds={1800} refresh={100} render={SecondsTimer} />

            </header>
        </div>
    );
}

export default App;